#!/usr/bin/perl -w
# 2003/12/16 - I. Dutour

# utilisation : ./chrom.pl kinases_map.txt 9

my ($file,$nombre,@resultat);

# Rcupration arguments
die "Manque le(s) argument(s) sur la ligne de commande\n" if (!defined(@ARGV));
($file,$nombre) = @ARGV;

# Ouverture du fichier contenant le rapport
open (REP, $file) || die (print "cannot open \"$file\": $!\n"); 

# Vrifier si nombre est l et correct
die "Manque un nombre sur la ligne de commande\n" if (!defined($nombre));
die "Nombre pas correct\n" if (!($nombre=~/^\d+$/));

# Dbut affichage
print "-----------------------------------------------------------------------------------\n";
print "Gene Symbol\tDate\tCytogenic Location\n";

# Traitement de chaque ligne
while (<REP>) {
    last
	if (/^$/);
    chomp; 
    @resultat=split (/\|/,$_);

    chromosome($nombre);
}

# Fin d'affichage
print "fin\n"; 
print "-----------------------------------------------------------------------------------\n";

#Fermeture du handle de fichier
close (REP) || die (print "cannot close \"$file\": $!");

###
# Fin du script
###

# Definitions des fonctions

sub afficher {
    print "$resultat[0]\t$resultat[2]\t$resultat[3]\n";
}

sub chromosome {
    my $num_chrom=$_[0];
    # $chromosome non defini si autre que chiffre
    ($chromosome)=($resultat[3] =~ /((Chr\.(\d+))|(\w+)[pqc])/);
    ($chromosome)=($chromosome =~ /(\d+)/);
    if ($chromosome && $chromosome==$num_chrom){
	afficher();
    }
}
